from flask import Flask
from sqlalchemy import create_engine,String,Integer,Column
from sqlalchemy.ext.declarative import declarative_base
from sqlalchemy.orm import sessionmaker,scoped_session
from graphene_sqlalchemy import SQLAlchemyObjectType
from flask_graphql import GraphQLView
import graphene

HOST = '127.0.0.1'
PORT = 3306
USER = 'root'
PWD = 'root'
DATABASE = 'acmy'

DB_URI = f'mysql+pymysql://{USER}:{PWD}@{HOST}:{PORT}/{DATABASE}?charset=utf8'

engine = create_engine(DB_URI)

Base = declarative_base(engine)
db_session = scoped_session(sessionmaker(bind = engine))
Base.query = db_session.query_property() # 要使用get_query方法必须先调用这个

class Test(Base):
    __tablename__ =  'test03'
    uname = Column(String(6),nullable=False)
    id = Column(Integer,primary_key=True,autoincrement=True)

# Base.metadata.drop_all()
# Base.metadata.create_all()

# class MUtation(graphene.ObjectType):
#     pass

class Tests(SQLAlchemyObjectType):
    class Meta:
        model = Test


class Query(graphene.ObjectType):
    tests = graphene.List(Tests)

    def resolve_test(self,info):
        query = Tests.get_query(info) # 解析tests相当于解析TESTs,但是这其中的字段时来自数据库的model，所以getquery方法其实解析的就是通过这个类数据库的model的字段
        return query.all()


if __name__ == '__main__':
    app = Flask(__name__)
    schema = graphene.Schema(query= Query)
    app.add_url_rule('/test/',view_func=GraphQLView.as_view('test',schema = schema,graphiql = True))
    app.run(debug=True)
    




